int noisetable[65536];
int sawtable[65536];
int softsawtable[65536];
int trgl[65536];
int square[65536];

void SST_init()
{
double om,om2;
srand(0);
	for (int i=0;i<65536;i++) 
	{
	noisetable[i]=2*(rand()%32767-16384);
	//
	sawtable[i]=32767-i;
	//
	om=32767*cos(i/65536.0*180.0*3.14/180.0);om2=32767.0-i;
	if (om2<om) om=om2;
	softsawtable[i]=om;
	//
	om=i*2-32767;
	if (i>32767) om=32767-(i-32767)*2;
	trgl[i]=om;
	//
	om=32767;
	if (i>32767) om=-32767;
	square[i]=om;
	}
}
//--
void Noise(int freq,int amp) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*noisetable[(int)(freq*sct*65536.0/44100.0)&0xffff]/256;
}

void Saw(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*sawtable[(int)(freq*sct*65536.0/44100.0+faze*256)&0xffff]/256;
}

void SoftSaw(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*softsawtable[(int)(freq*sct*65536.0/44100.0+faze*256)&0xffff]/256;
}

void Triangle(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*trgl[(int)(freq*sct*65536.0/44100.0+faze*256)&0xffff]/256;
}

void Square(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*square[(int)(freq*sct*65536.0/44100.0+faze*256)&0xffff]/256;
}

void Sinus(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*32767*sin(freq*sct*360.0/44100.0*3.14/180.0+faze*360/256*3.14/180)/256;
}

void AbsSinus(int freq,int amp,int faze) {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=amp*32767*fabs(sin(freq*sct*360.0/44100.0*3.14/180.0+faze*360/256*3.14/180))/256;
}
//--
void Mixer(int st1,int st2,int amp1,int amp2,unsigned int o1,unsigned int o2,int mode)
{
double a;int sct;

if (st1>s_numofstages[current_sample]-2) st1=s_numofstages[current_sample]-2;
if (st2>s_numofstages[current_sample]-2) st2=s_numofstages[current_sample]-2;

switch (mode)
{
case 0:
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+st1*sample_len[current_sample]*2+o1)*amp1/256.0+
	  *(sbuf+st2*sample_len[current_sample]*2+o2)*amp2/256.0;

	if (a>32767) a=32767;if (a<-32767) a=-32767;
	
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	o1++;if (o1>=sample_len[current_sample]) o1=0;
	o2++;if (o2>=sample_len[current_sample]) o2=0;
	}
	break;

case 1:
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+st1*sample_len[current_sample]*2+o1)*amp1/256.0+
	  *(sbuf+st2*sample_len[current_sample]*2+o2)*amp2/256.0;
	
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	o1++;if (o1>=sample_len[current_sample]) o1=0;
	o2++;if (o2>=sample_len[current_sample]) o2=0;
	}
	break;

case 2:
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+st1*sample_len[current_sample]*2+o1)*amp1/256.0-
	  *(sbuf+st2*sample_len[current_sample]*2+o2)*amp2/256.0;

	if (a>32767) a=32767;if (a<-32767) a=-32767;
	
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	o1++;if (o1>=sample_len[current_sample]) o1=0;
	o2++;if (o2>=sample_len[current_sample]) o2=0;
	}
	break;

case 3:
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=(*(sbuf+st1*sample_len[current_sample]*2+o1)*amp1/256.0)*(*(sbuf+st2*sample_len[current_sample]*2+o2)*amp2/256.0)/256.0;

	if (a>32767) a=32767;if (a<-32767) a=-32767;
	
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	o1++;if (o1>=sample_len[current_sample]) o1=0;
	o2++;if (o2>=sample_len[current_sample]) o2=0;
	}
	break;

}

}

void Morf(int st1,int st2)
{
double a,p1,p2;int sct;

if (st1>s_numofstages[current_sample]-2) st1=s_numofstages[current_sample]-2;
if (st2>s_numofstages[current_sample]-2) st2=s_numofstages[current_sample]-2;


	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	p1=(double)sct/(double)sample_len[current_sample];
	p2=1.0-p1;

	a=*(sbuf+st1*sample_len[current_sample]*2+sct)*p1+
	  *(sbuf+st2*sample_len[current_sample]*2+sct)*p2;


	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	}
}

void Env (int amp1ofs,int amp1,int amp2ofs,int amp2)
{
double a,ic,ic2,p1;int b;
int stage;stage=current_s_stage-1;
if (stage>s_numofstages[current_sample]-2) stage=s_numofstages[current_sample]-2;

amp1*=4;amp2*=4;
memcpy(sbuf+current_s_stage*sample_len[current_sample]*2,
	   sbuf+stage*sample_len[current_sample]*2,
	   sample_len[current_sample]*2);

amp1ofs=amp1ofs*sample_len[current_sample]/100;
amp2ofs=amp2ofs*sample_len[current_sample]/100;
int i;
for (i=amp1ofs;i<amp2ofs;i++)
	{
	ic=((double)(i-amp1ofs))/((double)(amp2ofs-amp1ofs));
	ic2=1-ic;
	p1=amp2*ic+amp1*ic2;
	a=*(sbuf+current_s_stage*sample_len[current_sample]*2+i)*p1;
	a=a/256;
	if (a>32767) a=32767;
	if (a<-32767) a=-32767;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+i)=(short int)(a);
	}
	
}

void Flanger(int speed,int depth)
{
double a,b,c,cc;int sct;
double o1,o2;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	cc=((double)sct)/((double)sample_len[current_sample]);
	o1=sct+depth*sin(cc*2*3.141519*((double)speed)/64.0)/2.0;
	o2=sct-depth*sin(cc*2*3.141519*((double)speed)/64.0)/2.0;

	if (o1>=sample_len[current_sample]) o1=0;
	if (o2>=sample_len[current_sample]) o2=0;

	b=*(sbuf+st*sample_len[current_sample]*2+(int)o1)/2.0;
	c=*(sbuf+st*sample_len[current_sample]*2+(int)o2)/2.0;

	a=b+c;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	}
}

void Shift(int ofs)
{
double a,b,c,cc;int sct;
double o1,o2;
ofs=2*((ofs-50)*sample_len[current_sample]/100);
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	o1=sct+ofs;
	if (o1>=sample_len[current_sample]) 
		{
		*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=0;
		}
	if (o1<0) 
		{
		*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=0;
		}
	if (o1>=0&&o1<sample_len[current_sample]) 
		{
		a=*(sbuf+st*sample_len[current_sample]*2+(int)o1);
		*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		}
	}
}

void Roll(int ofs)
{
double a,b,c,cc;int sct;
double o1,o2;
ofs=2*((ofs-50)*sample_len[current_sample]/100);
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	o1=sct+ofs;
	if (o1>=sample_len[current_sample]) o1-=sample_len[current_sample];
	if (o1<0) o1+=sample_len[current_sample];
		a=*(sbuf+st*sample_len[current_sample]*2+(int)o1);
		*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;

	}
}

void Vibrato(int speed,int depth)
{
double a,b,c,cc;int sct;
double o1,o2;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	cc=((double)sct)/((double)sample_len[current_sample]);
	o1=sct+8*depth*sin(cc*2*3.141519*((double)speed)/64.0)/2.0;
	if (o1>=sample_len[current_sample]) o1=0;

	b=*(sbuf+st*sample_len[current_sample]*2+(int)o1)/2.0;
	a=b;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	}
}

void Resample(int speed)
{
double a;int sct;
double o1;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	o1=sct/44100.0;
	o1=o1*speed*100;
	if (o1<sample_len[current_sample]) 
		{
		a=*(sbuf+st*sample_len[current_sample]*2+(int)o1);
		}
	else 
		{
		a=0;
		}
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}

void Invert()
{
double a;int sct;
int stage;stage=current_s_stage-1;
if (stage>s_numofstages[current_sample]-2) stage=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+stage*sample_len[current_sample]*2+sct);
	a=a*-1;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}


void Compress(int e)
{
double a,b,d;int sct;
d=((double)e)/255.0;
int stage;stage=current_s_stage-1;
if (stage>s_numofstages[current_sample]-2) stage=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+stage*sample_len[current_sample]*2+sct);
	b=(32768-fabs(a))/32678.0;
	a=a*d+a*b*(1-d)*4;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}

void Compress2(int e)
{
double a,b,d;int sct;
d=((double)e)/255.0;
int stage;stage=current_s_stage-1;
if (stage>s_numofstages[current_sample]-2) stage=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+stage*sample_len[current_sample]*2+sct);
	b=(32768-fabs(a))/32678.0;
	b=b*b;
	a=a*d+a*b*(1-d)*4;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}


#define BUFF_SIZE  1024*16
int LO_FRQ;//     44100/300
int HI_FRQ;//     44100/3000

int e_buff[BUFF_SIZE];
int e_head;                   /*   p */

long hi_acc;                  /*  p  */
long lo_acc;                  /*     */
int pre;

short filter(int c)         /* c -      p. */
{                             /*   p     */
                              /*    */

    int lo_tale;              /*    */
    int hi_tale;              /*    */

//    if(!st && --e_head < 0) e_head = EBUFF_SIZE-1;    /*   p */
    if(--e_head < 0) e_head = BUFF_SIZE-1;    /*   p */
    e_buff[e_head] = c;                               /*  */

    /* H */
    lo_tale = e_head + LO_FRQ;     /* p    */
    if (lo_tale >= BUFF_SIZE) lo_tale -= BUFF_SIZE;

    lo_acc -= e_buff[lo_tale];     /* p     */
    lo_acc += c;                   /* p.    */
                                   /*   */
    /*  */
    hi_tale = e_head + HI_FRQ;     /* p    */
    if(hi_tale >= BUFF_SIZE)
        hi_tale -= BUFF_SIZE;

    hi_acc -= e_buff[hi_tale];     /* p     */
    hi_acc += c;                   /* p.    */
                                   /*   */

    /*    p      */

	 return int((double)(lo_acc)/(double) (LO_FRQ+1) - ((double)(hi_acc) / (double)(HI_FRQ+1)));
//	 if (pre<LO_FRQ+1) pre++;
}

void eqv(int f1,int f2,int gain,int st,int gl_gain)
{
	int c;int sct;double a,d;
	LO_FRQ=f1;HI_FRQ=f2;
	e_head=0;for (int i=0;i<BUFF_SIZE;i++) e_buff[i]=0;
	lo_acc=0;hi_acc=0;
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	c=*(sbuf+st*sample_len[current_sample]*2+sct);
	d=filter(c);
	d=(gl_gain*gain*d/256)/256;
	d=d+*(sbuf+current_s_stage*sample_len[current_sample]*2+sct);
	if (d>32767) d=32767; if (d<-32767) d=-32767;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)(d);
	}
}

void Eq(int f1,int f2,int f3,int f4,int f5,int f6)
{
double gg;int g;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

for (int i=0;i<sample_len[current_sample];i++)
{
*(sbuf+current_s_stage*sample_len[current_sample]*2+i)=0;
}

gg=256*((double)255.0*6.0)/((double)(f1+f2+f3+f4+f5+f6));
g=(int)gg;

eqv(5,35,f1,st,g);
eqv(35,70,f2,st,g);
eqv(70,100,f3,st,g);
eqv(100,150,f4,st,g);
eqv(150,250,f5,st,g*2);
eqv(250,400,f6,st,g*3);

}

void Pluck(int f1,int f2,int bandwidth)
{
int c,d;int sct;double a,p1,p2;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

e_head=0;for (int i=0;i<BUFF_SIZE;i++) e_buff[i]=0;
lo_acc=0;hi_acc=0;
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	p2=((double)sct)/((double)sample_len[current_sample]);
	p1=((double)f1)*p2+((double)f2)*(1.0-p2);
	LO_FRQ=p1-bandwidth;HI_FRQ=p1+bandwidth;
	c=*(sbuf+st*sample_len[current_sample]*2+sct);
	d=filter(c);
	if (d>32767) d=32767;
	if (d<-32767) d=-32767;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)d;
	}
}


void Reverse()
{
	double a;int sct;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;
	
	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=*(sbuf+st*sample_len[current_sample]*2+sample_len[current_sample]-sct-1);
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}

void VRoll(int f)
{
double a,b,c,cc;int sct;
int st;st=current_s_stage-1;
if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

	for (sct=0;sct<sample_len[current_sample];sct++) 
	{
	cc=((double)sct)/((double)sample_len[current_sample]);
	a=*(sbuf+st*sample_len[current_sample]*2+sct);

	a=a+(f-127)*512;
	if (a>32767) a=32767-(a-32767);
	if (a<-32767) a=-32767-(a+32767);

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
		
	}
}

void Reverb(int bias,int k1,int k2)
{
double a,b,c,cc;int sct,double k;double klim,k2_;
int st;st=current_s_stage-1;
klim=(double)k1;
k2_=k2;

if (st>s_numofstages[current_sample]-2) st=s_numofstages[current_sample]-2;

memcpy(sbuf+current_s_stage*sample_len[current_sample]*2,
	   sbuf+st*sample_len[current_sample]*2,
	   sample_len[current_sample]*2);

	for (sct=0;sct<sample_len[current_sample]-bias;sct++) 
	{
	k=(((double)sct*k2_)/256.0/64.0);
	if (k>klim) k=klim;
		//if (k<k1) k=k+k2/64.0;
		//k=k1;
	a=*(sbuf+current_s_stage*sample_len[current_sample]*2+sct);
	b=*(sbuf+current_s_stage*sample_len[current_sample]*2+sct+bias);
	a=k*a/64.0+b;
	if (a>32767) a=32767-(a-32767);
	if (a<-32767) a=-32767-(a+32767);

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct+bias)=(short int)a;
		
	}
}

//complex

SinPack() {
for (int sct=0;sct<sample_len[current_sample];sct++) 
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=
	6096*sin(22.5*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(55*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(110*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(220*sct*360.0/44100.0*3.14/180.0)+
	2096*sin(440*sct*360.0/44100.0*3.14/180.0)+
	1396*sin(880*sct*360.0/44100.0*3.14/180.0)+
	196*sin(1720*sct*360.0/44100.0*3.14/180.0)+
	96*sin(2*1720*sct*360.0/44100.0*3.14/180.0);
}

void SinPack2(int startfreq,int amp1,int amp2,int amp3,int amp4,int amp5,int amp6) {
double freq,a,b;
double a1,a2,a3,a4,a5,a6;
a1=amp1;a2=amp2;a3=amp3;a4=amp4;a5=amp5;a6=amp6;
freq=startfreq;
for (int sct=0;sct<sample_len[current_sample];sct++) 
	{
	b=32767*(a1*sin(freq*sct*360.0/44100.0*3.14/180.0)/256.0+
	a2*sin(freq*2.0*sct*360.0/44100.0*3.14/180.0)/256.0+
	a3*sin(freq*3.0*sct*360.0/44100.0*3.14/180.0)/256.0+
	a4*sin(freq*4.0*sct*360.0/44100.0*3.14/180.0)/256.0+
	a5*sin(freq*5.0*sct*360.0/44100.0*3.14/180.0)/256.0+
	a6*sin(freq*6.0*sct*360.0/44100.0*3.14/180.0)/256.0)/6.0;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)b;
	}
}


void SSawPack(int startfreq,int amp1,int amp2,int amp3,int amp4,int amp5,int amp6) {
double freq,a,b;
double a1,a2,a3,a4,a5,a6;
a1=amp1;a2=amp2;a3=amp3;a4=amp4;a5=amp5;a6=amp6;
	freq=startfreq;
for (int sct=0;sct<sample_len[current_sample];sct++) 
	{

	b=0;
	b=b+a1*softsawtable[(int)(freq*sct*65536.0/44100.0)&0xffff]/256.0;
	b=b+a2*softsawtable[(int)(2*freq*sct*65536.0/44100.0)&0xffff]/256.0;
	b=b+a3*softsawtable[(int)(3*freq*sct*65536.0/44100.0)&0xffff]/256.0;
	b=b+a4*softsawtable[(int)(4*freq*sct*65536.0/44100.0)&0xffff]/256.0;
	b=b+a5*softsawtable[(int)(5*freq*sct*65536.0/44100.0)&0xffff]/256.0;
	b=b+a6*softsawtable[(int)(6*freq*sct*65536.0/44100.0)&0xffff]/256.0;

	b=b/6.0;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)b;
	}
}


SinPackSlide(int spd,int startfreq) {
double freq,a;
for (int sct=0;sct<sample_len[current_sample];sct++) 
	{
	a=(double)(spd-128)*(double)sct;
	freq=startfreq-a/256.0;
	if (freq<30) freq=30;
	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=
	6096*sin(freq/16.0*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(freq/8.0*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(freq/4.0*sct*360.0/44100.0*3.14/180.0)+
	6096*sin(freq/2.0*sct*360.0/44100.0*3.14/180.0)+
	2096*sin(freq*sct*360.0/44100.0*3.14/180.0)+
	1396*sin(freq*2.0*sct*360.0/44100.0*3.14/180.0)+
	196*sin(freq*4.0*sct*360.0/44100.0*3.14/180.0)+
	96*sin(freq*8.0*sct*360.0/44100.0*3.14/180.0);
	}
}

void BaseDrum() {
double b,a;
for (int sct=0;sct<sample_len[current_sample];sct++) 
	{
		a=32767*sin((440.0*6.0/(sct/800.0+1.0))*sct*360.0/44100.0*3.14/180.0);
		b=32767*sin((440.0*8.0/(sct/700.0+1.0))*sct*360.0/44100.0*3.14/180.0);a=(a+b)/2;
		b=32767*sin((440.0*4.0/(sct/400.0+1.0))*sct*360.0/44100.0*3.14/180.0);a=(a+b)/2;
		b=32767*sin((440.0*2.0/(sct/800.0+1.0))*sct*360.0/44100.0*3.14/180.0);a=(a+b)/2;
		b=32767*sin((440.0*1.0/(sct/900.0+1.0))*sct*360.0/44100.0*3.14/180.0);a=(a+b)/2;

	*(sbuf+current_s_stage*sample_len[current_sample]*2+sct)=(short int)a;
	}
}
