//-service func for texturegen routines
int _rgb;
int _r,_g,_b;
int tsize=32;

int tx_base[10],tx_amp[10],tx_spd[10],tx_fz[10];

inline void get_rgb(BYTE* dst,int x,int y){
	_asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		mov		eax, dword ptr[ edi ];
		mov		_rgb, eax;
	}
}

inline void place_rgb(BYTE* dst,int x,int y){
	_asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		mov		eax, _rgb;
		mov		[edi], ax;
		shr eax,16
		mov		[edi+2], al;
	}
}

inline void get_r_g_b(BYTE* dst,int x,int y){
	__asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		xor		eax, eax;
		mov		al, [ edi ];
		mov		_r, eax;
		mov		al, [ edi + 1 ];
		mov		_g, eax;
		mov		al, [ edi + 2 ];
		mov		_b, eax;
	}
}

void placeif1_rgb(BYTE* dst,int x,int y){
	__asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		mov		eax, _rgb;
		mov		ebx, dword ptr[ edi ];
		cmp		al, bl;
		ja		zz1;
		mov		al, bl;
zz1:	cmp		ah, bh;
		ja		zz2;
		mov		ah, bh;
zz2:	mov		[edi], ax;
		shr		eax, 16;
		cmp		al, bl;
		ja		zz3;
		mov		al, bl;
zz3:	mov		[edi+2],al;
	}
}

inline void place_r_g_b(BYTE* dst,int x,int y){
	__asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		mov		eax, dword ptr[ _b ];
		shl		eax, 16;
		mov		ebx, dword ptr[ _g ];
		shl		ebx, 8;
		or		eax, ebx;
		or		eax, dword ptr[ _r ];
		mov		[edi],ax;
		shr eax,16
		mov		[edi+2],al;
	}
}

inline void add_rgb(BYTE* dst,int x,int y){
	__asm{
		mov		eax, tsize;
		mul		y;
		add		eax, x;
		shl		eax, 2;
		add		eax, dst;
		mov		edi, eax;
		movd	mm0, dword ptr[ _rgb ];
		movd	mm1, dword ptr[ edi ];
		paddusb	mm0, mm1;
		movd	dword ptr[ edi ], mm0;
		emms;
	}
}

//--------------------
//memory service
inline void a_pokeb (BYTE* addr,BYTE value){
	__asm{
		mov		edi, addr;
		mov		al, value;
		mov		ah, byte ptr[ edi ];
		add		al, ah;
		jnc		m0;
		mov		al, 255;
m0:		mov		byte ptr[ edi ], al;
	}
}

inline void b_pokeb (BYTE* addr,BYTE value){
	__asm{
		mov		edi, addr;
		mov		al, value;
		mov		ah, byte ptr[ edi ];
		sub		ah, al;
		jnc		m0;
		mov		al, 0;
m0:		mov		byte ptr[ edi ], al;
	}
}

__forceinline void pokeb (BYTE* addr,BYTE value){
	_asm{
		 mov al,value
		 mov edi,addr
		 mov [edi],al
		}
}

__forceinline void poke (BYTE* addr,WORD value){
	_asm{
		 mov ax,value
		 mov edi,addr
		 mov [edi],ax
		}
}

__forceinline void poked (BYTE* addr,DWORD value){
	_asm{
		 mov eax,value
		 mov edi,addr
		 mov [edi],eax
		}
}

long memtemp;

__forceinline peekd (BYTE* addr){
	_asm{
		 mov edi,addr
		 mov eax,[edi]
		 mov memtemp,eax
		}
	return (memtemp);
}

__forceinline peek (BYTE* addr){
	_asm{
		 mov edi,addr
			 xor eax,eax
		 mov ax,[edi]
		 mov memtemp,eax
		}
	return ((int)memtemp);
}

__forceinline peekb (BYTE* addr){
	_asm{
		 mov edi,addr
			 xor eax,eax
		 mov al,[edi]
		 mov memtemp,eax
		}
	return ((unsigned char)memtemp);
}