#ifndef	TYPES_H
#define	TYPES_H

#include	"d3dx9.h"

#define		XYZ			(D3DFVF_XYZ)
#define		XYZT1		(D3DFVF_XYZ | D3DFVF_TEX1)
#define		XYZT2		(D3DFVF_XYZ | D3DFVF_TEX2)
#define		XYZNT1		(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)
#define		XYZNT2		(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX2)

struct _XYZ
{
	FLOAT		x, y, z;
};

struct _XYZT
{
	FLOAT		x, y, z;
	FLOAT		tu, tv;
};

struct _XYZT2
{
	FLOAT		x, y, z;
	FLOAT		tu, tv;
	FLOAT		tu2, tv2;
};

struct _XYZN
{
   float x, y, z;
   float nx, ny, nz;
};

struct _XYZNT1
{
	_XYZNT1() {}
	_XYZNT1 (float x, float y, float z, float nx, float ny, float nz, float u, float v)
	{
		_x  = x;  _y  = y;  _z  = z;
		_nx = nx; _ny = ny; _nz = nz;
		_u  = u;  _v  = v;
	}

	float _x, _y, _z;
	float _nx, _ny, _nz;
	float _u, _v;

	static const DWORD FVF;
};

struct _XYZNT2
{
	_XYZNT2() {}
	_XYZNT2 (float x, float y, float z, float nx, float ny, float nz, float u, float v, float u2, float v2)
	{
		_x  = x;  _y  = y;  _z  = z;
		_nx = nx; _ny = ny; _nz = nz;
		_u  = u;  _v  = v;
		_u2  = u2;  _v2  = v2;
	}

	float _x, _y, _z;
	float _nx, _ny, _nz;
	float _u, _v;
	float _u2, _v2;

	static const DWORD FVF;
};


struct _XYZT1
{
	_XYZT1() {}
	_XYZT1 (float x, float y, float z, float u, float v)
	{
		_x  = x;  _y  = y;  _z  = z;
		_u  = u;  _v  = v;
	}

	float _x, _y, _z;
	float _u, _v;
};

struct	MATRIX16
{
	float	_11; float	_12; float	_13; float	_14;
	float	_21; float	_22; float	_23; float	_24;
	float	_31; float	_32; float	_33; float	_34;
	float	_41; float	_42; float	_43; float	_44;
};


class	VECTOR2
{
public:
	VECTOR2	(float	x_, float y_)
	{
		x=x_;
		y=y_;
	}

	VECTOR2	(void) {};
	float	x;
	float	y;
};

class	VECTOR3
{
public:
	VECTOR3	(float	x_, float y_, float z_)
	{
		x=x_;
		y=y_;
		z=z_;
	}

	VECTOR3	(void) {};
	float	x;
	float	y;
	float	z;

};

class	VECTOR4
{
public:
	VECTOR4	(float	x_, float y_, float z_, float w_)
	{
		x=x_;
		y=y_;
		z=z_;
		w=w_;
	}

	VECTOR4	(void) {};
	float	x;
	float	y;
	float	z;
	float	w;

};

struct PLANE
{
	float	a, b, c, d;
};

struct UV
{
	float	u;
	float	v;
};


#endif